#push功能的代理选择用哪种推送工具1.个推 2.小米 3.华为
class PushToolClient
  
  def initialize(opts={})
    opts = HashWithIndifferentAccess.new(opts)
    @user_ids = opts[:user_ids]
    @opts = opts
  end

  def do_push
    Settings.platform = @opts[:app_type] || Settings::DEFAULT

    igetui_android_client_ids, igetui_ios_client_ids, xiaomi_client_ids, huawei_client_ids = fetch_client_ids

    if igetui_android_client_ids.present?
      Igetui::Pusher.new(igetui_android_client_ids, @opts.merge(device_platform: 'android')).perform
      NotificationStatistic.static_notification(@opts, igetui_android_client_ids,'igetui', 'android' )
    end
 
    if igetui_ios_client_ids.present?
      Igetui::Pusher.new(igetui_ios_client_ids, @opts.merge(device_platform: 'ios')).perform
      NotificationStatistic.static_notification(@opts, igetui_ios_client_ids,'igetui', 'android' )
    end

    #现在好像不用了
    # Push::IgetuiIos.push(@push_collections[:igetui_ios], @opts) if @push_collections[:apns].present?
    # Push::IgetuiAndroid.push(@push_collections[:igetui_android], @opts) if @push_collections[:apns].present?


    if xiaomi_client_ids.present?
      Xiaomi::Pusher.new(xiaomi_client_ids, @opts[:message]).perform
      NotificationStatistic.static_notification(@opts, xiaomi_client_ids,'xiaomi')
    end

    if huawei_client_ids.present?
      Huawei::Pusher.new(huawei_client_ids, @opts[:message]).perform
      NotificationStatistic.static_notification(@opts, huawei_client_ids,'huawei')
    end
  end
  
  def fetch_client_ids
    igetui_android_client_ids = igetui_ios_client_ids = xiaomi_client_ids = huawei_client_ids = []
    
    if (@opts[:device_ids_opts].is_a? Hash) && @user_ids.blank?
      push_devices = @opts[:device_ids_opts].keys.map(&:to_s)
      if push_devices.include? "igetui"
        igetui_android_client_ids = @opts[:device_ids_opts][:igetui] if @opts[:igetui_opts][:device_platform] == 'android'
        igetui_ios_client_ids = @opts[:device_ids_opts][:igetui] if @opts[:igetui_opts][:device_platform] == 'ios'
      end

      huawei_client_ids = @opts[:device_ids_opts][:huawei] if push_devices.include? "huawei"
      xiaomi_client_ids = @opts[:device_ids_opts][:xiaomi] if push_devices.include? "xiaomi"
    
      if @opts[:igetui_opts].is_a? Hash
        @opts[:igetui_opts][:device_platform]
      end
    else
      push_device_collections = UserDevice.where(user_id: @user_ids).group_by(&:platform)

      igetui_push_device_collections = push_device_collections['igetui'].group_by(&:device_platform) if push_device_collections['igetui'].is_a? Array
      if igetui_push_device_collections.is_a? Hash
        igetui_android_client_ids = igetui_push_device_collections['android'].map(&:client_id) if igetui_push_device_collections['android'].is_a? Array
        igetui_ios_client_ids = igetui_push_device_collections['ios'].map(&:client_id) if igetui_push_device_collections['ios'].is_a? Array
      end

      xiaomi_client_ids = push_device_collections['xiaomi'].map(&:client_id) if push_device_collections['xiaomi'].is_a? Array
      huawei_client_ids = push_device_collections['huawei'].map(&:client_id) if push_device_collections['huawei'].is_a? Array
    end
    
    [igetui_android_client_ids, igetui_ios_client_ids, xiaomi_client_ids, huawei_client_ids]
  end
end